
#define elif else if
#define and &&
#define or ||
#define not !
#define zmalloc(ayte) ({char *ret=malloc(ayte);*ret='\0';ret;})
#define freez(e) (free(e),e=0)
#define strlchr(a,b) (!(b)?0:strchr(a,b))
//#define dprint(d,...) ({char *tmp;dprintf(d,"%s",tmp=strp(0,__VA_ARGS__));free(tmp);})
#define dprint(d,...) ({char **av=list(__VA_ARGS__);while(*av){dprintf(d,"%s",*av);av+=1;}})
#define print(...) ({char *tmp;printf("%s",tmp=strp(0,__VA_ARGS__));free(tmp);})
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))

int listlen(char **av)
	int ac=0 ;while(*av){av+=1;ac+=1;} ;return ac
char **listcopy(char **dest,char **av)
	while(*av!=NULL){*dest=*av;av+=1;dest+=1;} return dest
char **listncopy(char **dest,char **s,int n1)
	int n=0
	while(1){if(n>=n1)break;n+=1;*dest=*s;s+=1;dest+=1;} return dest
char **listnmove(char **dest,char **s,int n1)
	int n=0
	if(n1>0)
		s=s+n1-1 ;while(1){if(n>=n1)break;n+=1;*dest=*s;s-=1;dest-=1;}
	else
		n1=-n1;s=s-(n1-1) ;while(1){if(n>=n1)break;n+=1;*dest=*s;s+=1;dest+=1;}
	return dest

char **strnlistfind(char **av,char *key)
	char **ret=0;int ac=0 ;while(*av){if(!strncmp(*av,key,strlen(*av))){ret=av;break;}av+=1;ac+=1;} ;return ret
int strnlistfind_off(char **av,char *key)
	char **a=strnlistfind(av,key);return !a?-1:a-av
char **strlistfind(char **av,char *key)
	char **ret=0;int ac=0 ;while(*av){if(!strcmp(*av,key)){ret=av;break;}av+=1;ac+=1;} ;return ret
int strlistfind_off(char **av,char *key)
	char **a=strlistfind(av,key);return !a?-1:a-av
int strlistcount(char **av,char *key)
	char **res;int c=0
	while(1)
		res=strlistfind(av,key)
		if(!res)break;c+=1;av=res+1
	return c
void listremove(char **elm)
	if(elm);else return;char **dest=listcopy(elm,elm+1);*dest=NULL
#define vatail(a,...) __VA_ARGS__
#define listoflist(...) (char**[]){vatail(0,##__VA_ARGS__,NULL)}
#define list(...) (char*[]){vatail(0,##__VA_ARGS__,NULL)}
#define pw(lit) (char*[]){lit}[0]
#define listpe(arr,...) arr=(typeof(arr))listp_(arr,&len_##arr,((char*[]){__VA_ARGS__,NULL}))
#define listp(arr,a,...) arr=(typeof(arr))listp_(0,&len_##arr,((char*[]){a,##__VA_ARGS__,NULL}))
#define listp_(av,len_avp,elemv) listp_1((char**)av,len_avp,elemv)
char **listp_1(char **av,int *len_avp,char **elemv)
	#define len_av (*len_avp)
	int len_elemv=listlen(elemv)
	av=realloc(av,sizeof(char*)*(len_av+len_elemv+1))
	memcpy(av+len_av,elemv,sizeof(char*)*(len_elemv+1))
	len_av+=len_elemv
	return av
	#undef len_av

/*maybe change malloc,free,so len is (int*)(void*)[-1]*/
#define nlistpe(arr,a) nlistpev(arr,1,a)
#define nlistp(arr,a) nlistpv(arr,1,a)
#define nlistpev(arr,cllen,...) arr=nlistp_(arr,&len_##arr,(int[]){__VA_ARGS__},cllen)
#define nlistpv(arr,cllen,...) arr=nlistp_(0,&len_##arr,(int[]){__VA_ARGS__},cllen)
int *nlistp_(int *av,int *len_avp,int *elemv,int len_elemv)
	#define len_av (*len_avp)
	av=realloc(av,sizeof(int)*(len_av+len_elemv+1))
	memcpy(av+len_av,elemv,sizeof(int)*(len_elemv+0))
	len_av+=len_elemv
	return av
	#undef len_av
//version 2:
#define array(type,...) (type[]){__VA_ARGS__}
//#define charlen(a) (*(((long*)a)-1))
#define charlen(a) ((long*)a)[-1]
#define arrlen(a,type) (charlen(a)/sizeof(type))
char *arralloc(long size)
	char *a=malloc(sizeof(long)+size)
	a=a+sizeof(long)
	charlen(a)=size
	return a
char *arrfree(char *a)
	free(a-sizeof(long));return 0
char *arrrealloc(char *a,long size)
	if(!a)
		return arralloc(size)
	a=realloc(a-sizeof(long),sizeof(long)+size)
	return a+sizeof(long)
#define arre(a,type,...) a=({char *b=(type[]){__VA_ARGS__};arrp_(a,b,sizeof(b),1);})
#define arrpe(a,type,...) a=({char *b=(type[]){__VA_ARGS__};arrp_(a,b,sizeof(b),0);})
#define arrp(type,...) arrp_(0,(type[]){__VA_ARGS__},sizeof((type[]){__VA_ARGS__}),0)
char *arrp_(char *av,char *elemv,long len_elemv,char e)
	char *tmp;if(e){tmp=av;av=NULL;}
	long len_av=!av?0:charlen(av)
	av=arrrealloc(av,len_av+len_elemv+0)
	memcpy(av+len_av,elemv,len_elemv)
	charlen(av)+=len_elemv
	if(e)arrfree(tmp);return av

char *singlequote(char *a1)
	char *a,*out=NULL ;int len ;static char *out1;if(out1)free(out1)
	#define putc_(c) {if(out)out[len]=c;len+=1;}
	while(1){a=a1;len=0 ;putc_('\'')
	while(*a)
		if(*a=='\'')putc_('\\');putc_(*a) ;a+=1
	if(*(a-1)=='\\'||*(a-1)=='/') putc_('/') ;putc_('\'')
	if(out)break;out=malloc(len+1);out[len]='\0';}out1=out;return out
	#undef putc_
void pargs(char **av)
	while(*av){printf("%s%c",singlequote(*av),' ') ;av+=1;}printf("\n")
#define fromstr(a) /*long(int)*/strtol(a,NULL,0/*base*/)
char *tostr(long numb)
	static char *str ;if(str) free(str)
	int len=snprintf(NULL,0,"%d",numb);str=malloc(len+1)
	snprintf(str,len+1,"%d",numb)
	return str
#define strpef(a,...) ({char *llstr;int lllen=snprintf(NULL,0,__VA_ARGS__);llstr=malloc(lllen+1);snprintf(llstr,lllen+1,__VA_ARGS__);strpe(a,llstr);free(llstr);a;})
#define dex(str,...) dex_(str,##__VA_ARGS__,0)
#define dex_(str,idx,...) dex_1(str,idx)
char *dex_1(char *str1,int idx)
	static char **stra ;static int len_stra
	if(len_stra<idx+1)
		stra=realloc(stra,sizeof(char*)*(idx+1))
		int i=idx ;while(i>=len_stra){stra[i]=NULL;i-=1;}
		len_stra=idx+1
	#define str stra[idx]
	if(str) free(str) ;str=strdup(str1) ;return str
	#undef str
int strchr_off(const char *s, int c)
	char *a=strchr(s,c);return !a?-1:a-s

#define  strpe(s,...) s=strp_(s,(char*[]){__VA_ARGS__,NULL},0)
#define  stre(s,...) s=strp_(s,(char*[]){__VA_ARGS__,NULL},1)
#define  strp(s,...) strp_(s,(char*[]){__VA_ARGS__,NULL},0)
char *strp_(char *str,char **av,char e)
	char *tmp;if(e){tmp=str;str=NULL;}
	int len,len1
	char **av1=av
	len=(!str)?0:strlen(str);len1=len
	while(*av != NULL)
		len+=strlen(*av);av+=1
	str=realloc(str,len+1) ;if(!len) *str='\0'
	av=av1 ;char *dest=str+len1
	while(*av!=NULL)
		strcpy(dest,*av);dest+=strlen(*av);av+=1
	if(e)free(tmp);return str
//
#define strpe_c(s,c) s=strp_c(s,c)
char *strp_c(char *str,char c)
	int len,len1
	len=(!str)?0:strlen(str);len1=len
	len+=1
	str=realloc(str,len+1)
	char *dest=str+len1
	*dest=c ;dest+=1 ;*dest='\0'
	return str
#define comma(a) a, /*no you can use () to escape ,s*/
//-(-( (#de))(fine str stri) )-

/*
#define f(a) f_(&a)
char *f_(char *(*strp))
	#define str (*strp)
	printf("f %s\n",str)
	#undef str
char *f1()
	char *var="a"
	f(var) ;f((var))
	f(pw("b")) ;f(pw(0))
*
insert/don't require ;before }
after #preprocess require/remove ;after{};
*
labels can be redefined. lab: a;(#fdefine lab lab1)lab: b(#undef lab)(#define lab lab2)lab: c
*/
